/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Classes;

import Interface.JFPrincipal;
import java.io.IOException;
import java.util.ArrayList;

/**
 *
 * @author Vitor
 */
public class JogoContraIA extends Thread implements Processo{
    
    JFPrincipal pai;
    
    private String coringa;
    private ArrayList<Jogador> jogadores;
    private boolean ftermina;
    private int jogadorQCaiPrimeiro;
    private int jogadorAcao;            //  1 - Jogar carta. 2 - Esconder.
    private String cartaAcao;
    private int jogadorRodada;
    private int rodadas[];                      //  Para poder descobrir a rodada de fora da classe.
    private int pontoPartida;           //  Pontuação disputada na partida. Inicialmente = 1
    private boolean onTruco;            //  Flag que define se jogador já está em truco ou não.    
    
    
    public JogoContraIA(JFPrincipal pai, String nome1, String nome2, int dif) {
        this.pai = pai;
        this.jogadores = new ArrayList<Jogador>();        
        jogadores.add(new JogadorHumano(nome1));
        System.out.println("Dificuldade: " + dif);
        if(dif == 0) {
            jogadores.add(new JogadorIAFacil(nome2));
        } else {
            jogadores.add(new JogadorIAMedio(nome2));   
        }
        
        this.ftermina = true;
        this.jogadorAcao = 0;
        this.onTruco = false;                
    }
    
    
    @Override
    public void run() {
        
        pai.setaProcesso(this);
        pai.setPlacar(jogadores.get(0).getPontuacao(), jogadores.get(1).getNome(), jogadores.get(1).getPontuacao());
        pai.setMaoDeOnze(false);        
        pai.alerta("Jogo iniciado!");
        this.iniciarJogo();
        int esc;
        do {
            esc = pai.trucoResposta("Reiniciar jogo?");
            if (esc == 0) {
                this.iniciarJogo();
            }
        } while (esc == 0);        
    }

    @Override
    public void enviarChat(int codigo, String cont) throws Exception{};
    
    public void iniciarJogo() {

        jogadorQCaiPrimeiro = sorteiaJogadorQCai(); //  Sorteia jogador que caira primeiro.       
        jogadores.get(0).setPontuacao(0);
        jogadores.get(1).setPontuacao(0);
        pai.setMaoDeOnze(false);
        
        pai.setPlacar(jogadores.get(0).getPontuacao(), jogadores.get(1).getNome(), jogadores.get(1).getPontuacao());
        
        do {
            //rodada, partida, jogo.
            this.iniciaPartida();
        } while (testaVitoria() && ftermina); // O loop termina quando algum jogador alcançar 12 pontos ou o flag de segurança for setado

        String ms = "Fim de jogo! ";
        if(jogadores.get(0).getPontuacao() > jogadores.get(1).getPontuacao()) {
            ms += jogadores.get(0).getNome() + " Venceu o Jogo!";
        } else {
            ms += jogadores.get(1).getNome() + " Venceu o Jogo!";
        }
        pai.alerta(ms);
    }    
    
    public void iniciaPartida() {
        
        //  Array de cartas. Na verdade só vai segurar dois valores por vez.
        String[][] cartas = {{"", "", ""}, {"", "", ""}};
        
        //  Seta pontuação inicial.
        pontoPartida = 1;
        
        int fEsconder = -1;  //  0 - jogador 1, 1 jogador 2;
        
        int quemLevou[] = {-1, -1, -1};      // -1 - Rodada não jogada; 5 - Empate; 0 - P1 levou; 1 - P2 levou;        
        
        //  Resetar flags onTruco.
        this.onTruco = false;

        //  Para tratar caso de empate na mão de onze.
        if((jogadores.get(0).getPontuacao() == jogadores.get(1).getPontuacao() &&
                jogadores.get(0).getPontuacao() == 11) ) {
            pai.setMaoDeOnze(true);
        }         
        
        distribuiMao();
        
        pai.exibirMao(jogadores.get(0).getCartas(), coringa);        
        jogadorRodada = jogadorQCaiPrimeiro;    //  Copia jogador que inicia a partida para a var de jogo local.
        do {
            rodadas = quemLevou;
            
            if (jogadorRodada == 0) {
                cartas[0][0] = pedirCartaServer();  //  Pede carta para o server.
                 if (cartas[0][0].equals("l")) {
                     fEsconder = 0;
                    break;
                } else if(cartas[0][0].equals("Tr")) { //    Segundo jogador recusou o truco.
                    quemLevou[0] = 0; quemLevou[1] = 0; quemLevou[2] = 0;
                    break;
                }
                cartas[1][0] = pedirCartaIA();  //  Pede carta para a IA.               
                if (cartas[1][0].equals("l")) {
                     fEsconder = 1;
                    break;
                } else if(cartas[1][0].equals("Tr")) { //    Segundo jogador recusou o truco.
                    quemLevou[0] = 1; quemLevou[1] = 1; quemLevou[2] = 1;
                    break;
                }
                
                quemLevou = calculaRodada(cartas[0][0], cartas[1][0], quemLevou);
                int a = informaJogador(quemLevou);                
                if(a != 5) jogadorRodada = a;
            } 
            else {
                cartas[1][0] = pedirCartaIA();  //  Pede carta para a IA.               
                if (cartas[1][0].equals("l")) {
                     fEsconder = 1;
                    break;
                } else if(cartas[1][0].equals("Tr")) { //    Segundo jogador recusou o truco.
                    quemLevou[0] = 1; quemLevou[1] = 1; quemLevou[2] = 1;
                    break;
                }           
                cartas[0][0] = pedirCartaServer();  //  Pede carta para o server.
                 if (cartas[0][0].equals("l")) {
                     fEsconder = 0;
                    break;
                } else if(cartas[0][0].equals("Tr")) { //    Segundo jogador recusou o truco.
                    quemLevou[0] = 0; quemLevou[1] = 0; quemLevou[2] = 0;
                    break;
                }            
                
                quemLevou = calculaRodada(cartas[0][0], cartas[1][0], quemLevou);                
                int a = informaJogador(quemLevou);
                if(a != 5) jogadorRodada = a;
            }
            pai.limpaCartasJogadas();            
            
        } while ((testaVencedorRodada(quemLevou) == -1)&&(fEsconder < 0));
        
        if(fEsconder > -1) {
            if(fEsconder == 0) {    //  Jogador servidor escondeu.
            //  Incrementa pontuação.
            jogadores.get(1).incPontuacao(pontoPartida);                
            //  Avisa jogador servidor sobre vencedor da partida.
            pai.alerta(jogadores.get(1).getNome() + " venceu a partida!");
            //  Atualiza placar.
            pai.setPlacar(jogadores.get(0).getPontuacao(), jogadores.get(1).getNome(), jogadores.get(1).getPontuacao());             
            }
            else {  //  Jogador cliente escondeu.
            //  Incrementa pontuação.
            jogadores.get(0).incPontuacao(pontoPartida);                
            //  Avisa jogador servidor sobre vencedor da partida.
            pai.alerta(jogadores.get(0).getNome() + " venceu a partida!");
            //  Atualiza placar.
            pai.setPlacar(jogadores.get(0).getPontuacao(), jogadores.get(1).getNome(), jogadores.get(1).getPontuacao());               
            }
            pai.limpaCartasJogadas();
        }
        else {
            int a = testaVencedorRodada(quemLevou);
            //  Incrementa pontuação.
            jogadores.get(a).incPontuacao(pontoPartida);
            //  Avisa jogador servidor sobre vencedor da partida.
            pai.alerta(jogadores.get(a).getNome() + " venceu a partida!");
            //  Atualiza placar.
            pai.setPlacar(jogadores.get(0).getPontuacao(), jogadores.get(1).getNome(), jogadores.get(1).getPontuacao());
            pai.limpaCartasJogadas();
        }
        //  Se jogador que caiu agora é o 1 e o flag de empate não está true.
        if(jogadorQCaiPrimeiro == 0) {
            jogadorQCaiPrimeiro = 1;
        }
                
        //  Se jogador que caiu agora é o 2 e o flag de empate não está true.                
        else if(jogadorQCaiPrimeiro == 1) {
            jogadorQCaiPrimeiro = 0;
        }
    }    
    
    @Override
    public void incPontoPartida(int valor) {
        pontoPartida += valor;
    }    
    
    public int sorteiaJogadorQCai() {
        return (int)(2*Math.random());
    }    
    
    public boolean testaVitoria() {
        if( (jogadores.get(0).getPontuacao() >= 12) || (jogadores.get(1).getPontuacao() >= 12)) {
            return false;
        }
        return true;
    }    
    
    //  Pede a carta para o jogador local.
    public String pedirCartaServer() {
        
        pai.solicitaCarta();
        
        //jogadorAcao = 0;
        while(jogadorAcao == 0);  //  Aguarda ação do jogador.
        
        switch(jogadorAcao) {
            
                //  Jogada normal.
            case 1:
                pai.exibirCartaJogada(cartaAcao);                
                return cartaAcao;
                //  Esconder.
            case 2:
                pai.exibirCartaJogada("0o");
                return "0o";
                //  Largar mão.
            case 3:
                return "l";                
                //  Caso pedido de truco foi recusado.
            case 4:
                return "Tr";
                
            default:
                System.out.println("Default");
                break;
        }
        return "";
    }    
    
    public String pedirCartaIA() {
        String ca = ((IA)jogadores.get(1)).getJogada(this);
        
        pai.exibirCartaJogada(ca);
        pai.limparUmaCartaAdver();
        return ca;   //  A lógica está no código do jogador.
    }

   public int informaJogador(int quemLevou[]) {  

        int i = qualRodada(quemLevou);
        
        if (quemLevou[i] != 5) {       
            pai.alerta(jogadores.get(quemLevou[i]).getNome() + " venceu a rodada!");
            return quemLevou[i];
        } 
        else {      
            pai.alerta("A rodada empatou!");
            return 5;
        }
    }
    
    public int[] calculaRodada(String cartaP1, String cartaP2, int quemLevou[]) {        
        
        int p1 = valorDaCarta(cartaP1);
        int p2 = valorDaCarta(cartaP2);
        
        //  Primeira Rodada
        if (quemLevou[0] == -1) {
            
            if (p1 > p2) {          //  Jogador 1 vence.
                quemLevou[0] = 0;                
            } 
            else if (p2 > p1) {     //  Jogador 2 vence.
                quemLevou[0] = 1;
            } 
            else if (p1 == p2) {    //  Empatou a primeira.
                quemLevou[0] = 5;
            }
        }
        //  Segunda Rodada
        else if (quemLevou[1] == -1) {
            
            if (p1 > p2) {          //  Jogador 1 vence.
                quemLevou[1] = 0;                
            } 
            else if (p2 > p1) {     //  Jogador 2 vence.
                quemLevou[1] = 1;
            } 
            else if (p1 == p2) {    //  Empatou a segunda.
                
                if(quemLevou[0] != 5) {
                    
                    if(quemLevou[0] == 0) {     //  Quem venceu a primeira, vence partida.
                        quemLevou[1] = 0;
                    }
                    else {
                        quemLevou[1] = 1;
                    }                    
                }
                else {              //  Empatou a segunda.  quemLevou[0] == 5 - true
                    quemLevou[1] = 5;
                }                
            }            
        } 
        //  Terceira Rodada       
        else if (quemLevou[2] == -1) {
            
            if (p1 > p2) {          //  Jogador 1 vence.
                quemLevou[2] = 0;                
            } 
            else if (p2 > p1) {     //  Jogador 2 vence.
                quemLevou[2] = 1;
            } 
            else if (p1 == p2) {    //  Empatou a terceira.                
                if(quemLevou[0] != 5) {
                    
                    if(quemLevou[0] == 0) {     //  Quem venceu a primeira, vence partida.
                        quemLevou[2] = 0;
                    }
                    else {
                        quemLevou[2] = 1;
                    }                    
                }
                else if(quemLevou[1] != 5) {    //  Quem levou a segunda vence.
                    
                    if(quemLevou[1] == 0) {
                        quemLevou[2] = 0;
                    }
                    else {
                        quemLevou[2] = 1;
                    }   
                }
                else {                      //  Se empatou a primeira e a segunda, a carta de maior nipe vence.
                    if(valorDoNipe(cartaP1) > valorDoNipe(cartaP2)) {
                        quemLevou[2] = 0;
                    }
                    else {
                        quemLevou[2] = 1;
                    }
                }
            }            
        }
        return quemLevou;
    }    
    
    //  Retorna jogador vencedor ou -1 se ainda não foi possível decidir.
    public int testaVencedorRodada(int quemLevou[]) {        
        
        int p[] = {0, 0};
        
        //  Controle. Começa a testar apenas a partir da segunda rodada.
        if(quemLevou[1] == -1) {
            return -1;
        }
        //  Se alguém venceu a primeira.
        if(quemLevou[0] != 5) {
            p[quemLevou[0]]++;      //  Adiciona um ponto.
            
            if((quemLevou[1] != 5)&&(quemLevou[1] != quemLevou[0])) { //  Se alguém venceu a segunda rodada e não foi o mesmo jogador da primeira.
                p[quemLevou[1]]++;  //  Adiciona um ponto.
                
                if(quemLevou[2] != -1) {
                    p[quemLevou[2]]++;
                }
            }
            else {                  //  Se não quem venceu a primeira rodada, vence a partida.
                return quemLevou[0];
            }
        }                
        //  Se não se alguém venceu a segunda.
        else if (quemLevou[1] != 5) {
            return quemLevou[1];      //    Vencedor da segunda rodada vence.
        }        
        else if(quemLevou[2] != -1) {   //  Se a terceira rodada foi jogada.
            return quemLevou[2];        //  Se não quem venceu a terceira rodada ganha o ponto.
        }
        else {
            return -1;
        }
        
        //  Se jogador 1 fez mais pontos que jogador 2, vence jogador 1.
        if(p[0] > p[1]) {
            return 0;
        }
        else if (p[1] > p[0]){  //  Se não vence jogador 2.
            return 1;
        }
        else {
            return -1;
        }
    } 
    
    //  Distribui Mão e tira coringa.
    public void distribuiMao() {

        //  Embaralha as cartas.
        pai.embaralhar();
        
        //  Remover mão dos jogadores.
        jogadores.get(0).limparCartas();
        jogadores.get(1).limparCartas();

        // Retira duas mãos de cartas e o coringa
        ArrayList<String> cartas = pai.pegaCarta(7);

        //  Seta cartas do jogador 1.
        for (int i = 0; i < 6; i++) {
            if (i < 3) {
                jogadores.get(0).addCartas(cartas.get(i));
            } else {
                jogadores.get(1).addCartas(cartas.get(i));
            }
        }            
        coringa = cartas.get(6);        
    }
    
    public int valorDoNipe(String cartaP) {           

        if (cartaP.charAt(1) == 'o') {      //  Ouro
            return 0;
        }
        else if (cartaP.charAt(1) == 'e') { //  Espadas
            return 1;
        }
        else if (cartaP.charAt(1) == 'c') { //  Copas
            return 2;
        }
        else {                              //  Paus
            return 3;
        }
    }    
    
    public int valorDaCarta(String cartaP) {
        
        char[] p = {cartaP.charAt(0), cartaP.charAt(1)};
        
        int C1 = 0;
        
        char corV = coringa.charAt(0);
        char corN = coringa.charAt(1);
               
        //  Se a carta virada para o coringa for 7.
        if(corV == '7') {   //  Mais gambiarra.
            corV = 'd';     //  Que beleza que e java. Tratar char como char.
        } else {
            corV++;         //  Tratar char como inteiro. D:D
        }
        
        if(p[0] == corV) {
            
            if(cartaP.charAt(1) == 'o')
                C1 = 11;
            if(cartaP.charAt(1) == 'e')
                C1 = 12;
            if(cartaP.charAt(1) == 'c')
                C1 = 13;
            if(cartaP.charAt(1) == 'p')
                C1 = 14;                        
        }
        else {            
            if(cartaP.charAt(0) == '4')
                C1 = 1;
            if(cartaP.charAt(0) == '5')
                C1 = 2;
            if(cartaP.charAt(0) == '6')
                C1 = 3;
            if(cartaP.charAt(0) == '7')
                C1 = 4;
            if(cartaP.charAt(0) == 'd')
                C1 = 5;
            if(cartaP.charAt(0) == 'j')
                C1 = 6;
            if(cartaP.charAt(0) == 'q')
                C1 = 7;
            if(cartaP.charAt(0) == '1')
                C1 = 8;
            if(cartaP.charAt(0) == '2')
                C1 = 9;
            if(cartaP.charAt(0) == '3')
                C1 = 10;        
            if(cartaP.charAt(0) == '0')
                C1 = 0;              
        }
        return C1;
    }    
    //  Pergunta se IA vai em truco.
    public int getTrucoResp() {
        return ((IA)jogadores.get(1)).getTrucoResp();
    }
    
    @Override
    public void setaJogadorAcao(int acao) {
        this.jogadorAcao = acao;        //  1 - Escolheu uma carta; 2 - Largou mão; 3 - Trucou.
    }
    
    @Override
    public void setaCartaAcao(String carta) {
        this.cartaAcao = carta;
    }

    @Override
    public void enviar(int codigo, String cont) {
            //  Vazio mesmo!
    }

    @Override
    public Mensagem receber() throws IOException, ClassNotFoundException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public String getCoringa() {
        return coringa;
    }

    @Override
    public int[] getRodadas() {
        return rodadas;
    }

    @Override
    public int qualRodada(int quemLevou[]) {
        
        int i = 2;     
        //  Descobre em qual rodada o jogo está.
        for(; i > 0; i--) {
            if (quemLevou[i] > -1) {
                break;
            }
        }
        return i;
    }
    
    @Override
    public int condEsconder(int quemLevou[]) {
        
        int i = 2;     
        //  Descobre em qual rodada o jogo está.
        for(; i > 0; i--) {
            if (quemLevou[i] > -1) {
                break;
            }
        }
        //  Se o primeiro turno já foi decidido.
        if((i == 0)&&(quemLevou[i] != -1)) {
            return 1;
        }
        
        return i;                
    }

    @Override
    public int getPontoPartida() {
        return pontoPartida;
    }   

    @Override
    public void setOnTruco(boolean a) {
        this.onTruco = a;
    }
    @Override
    public boolean getOnTruco() {
        return onTruco;
    }    

}
