/****************************************************************************\
 * Instituto Federal de Educação, Ciência e Tecnologia de Santa Catarina    *
 * Campus São José                                                          *
 * **************************************************************************
 * Disciplina: Programação Orientada a Objetos                              *
 * Professor/Orientador: Emerson Ribeiro de Mello                           *
 * Aluno/Desenvolvedor: Vitor Rozsa                                         *
 * Contato: vitor.rozsa@hotmail.com                                         *
 * **************************************************************************
 * Created on 12/06/2011, 11:12:15
 * 
 *  A quem for utilizar os recursos do código: O projeto foi mal planejado e
 * este motivo existe uma grande quantidade de flags que foram acrescentados
 * para auxiliar no funcionamento de algumas funções (trucar, esconder, lagar
 * mão...).
 */

/*
* ----------------------------------------------------------------------------
* "LICENÇA BEER-WARE" 
*  Enquanto esta nota estiver na coisa você poderá utilizá-la como quiser. Caso 
* nos encontremos algum dia e você me reconheça e ache que esta coisa tem algum
* valor, você poderá me pagar uma cerveja em retribuição (ou mais de uma), ou ao
* meu professor, Vitor Rozsa & Emerson Ribeiro de Mello.
* ----------------------------------------------------------------------------
*/

package Interface;

import Classes.*;
import InterfaceJogoIA.jFPedirDados;
import java.awt.Color;
import java.net.InetAddress;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.Random;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;

/**
 *
 * @author Vitor
 */
public class JFPrincipal extends javax.swing.JFrame {

   private ArrayList<String> baralho;
   private ArrayList<Carta> cartasNaMesa;
   private ArrayList<Carta> cartasEmJogo;
   private ArrayList<Carta> cartasDoAdversario;
   private int posicialInicialX;// coordenada X onde deve aparecer a 1a. carta
   private int posicialInicialY;// coordenada Y onde deve aparecer a 1a. carta      
   private String nick;
   private ServidorThread serverSock;
   private ClienteThread clienteSock;
   private Random sementeAleatoria; // usada no embaralhamento das cartas
   private boolean suaVez;
   private boolean botoes;          //  Libera botões de ação.
   private boolean f;   //  flag da posição da carta jogada.
   private boolean fesconder;   //  Flag da ação esconder.
   private boolean flargarmao;
   private boolean ftrucar;     //  Flag da ação trucar.
   private Processo proc;
   private boolean fsolicitacarta;
   private boolean fjogoIA;
   private boolean maoDeOnze;
   
    /** Creates new form JFPrincipal */
    public JFPrincipal() {

        this.suaVez = false;
        this.sementeAleatoria = new Random();
        this.posicialInicialX = 5;
        this.posicialInicialY = 5;
        this.baralho = new ArrayList<String>();
        this.cartasNaMesa = new ArrayList<Carta>();
        this.cartasEmJogo = new ArrayList<Carta>();
        this.cartasDoAdversario = new ArrayList<Carta>();
        this.criaBaralho();
        initComponents();
        this.setLocationRelativeTo(null);
        this.setResizable(false);
        this.setTitle("Truco Virtual- Desenvolvido por Vitor Rozsa - Orientação por Emerson Ribeiro de Mello");
        this.botoes = false;
        this.f = true;
        this.fesconder = false;
        this.flargarmao = false;
        this.fsolicitacarta = false;
        this.ftrucar = false;
        this.fjogoIA = false;
        this.maoDeOnze = false;
    }

   public void criaBaralho() {

      String naipe = "oecp";
      String frente = "1234567dqj";

      for (int n = 0; n < naipe.length(); n++) {
         for (int f = 0; f < frente.length(); f++) {
            this.baralho.add("" + frente.charAt(f) + naipe.charAt(n));
         }
      }
   }

   public int getPosicialInicialX() {
      return posicialInicialX;
   }

   public int getPosicialInicialY() {
      return posicialInicialY;
   }    
   
   public String getNick() {
       return nick;
   }

//---------Misc
   public void mensagem(String msg) {
       msg += "\n";
       jTASistema.append(msg);
   }
   //   Fica aparecendo na frente das cartas. Ruim
   public void alerta(String msg) {
       //JOptionPane.showMessageDialog(this, msg, "Alerta", JOptionPane.INFORMATION_MESSAGE);
       JOptionPane.showMessageDialog(this, msg, "Alerta", 2, new javax.swing.ImageIcon(getClass().getResource("/resourcesEtc/Coração-icone.gif")));
       /*jDAlerta alerta = new jDAlerta(this, true, msg);
       alerta.setLocationRelativeTo(this);
       alerta.setLocation(alerta.getX()-50, alerta.getY() - 130);
       alerta.setVisible(true);*/
   }

   public void embaralhar() {       
       //   Remove todas as cartas da mesa.
       cartasNaMesa.clear();  
       ((Mesa) jPMesa).repaint();       
      // Embaralha os elementos do ArrayList
      Collections.shuffle(baralho, this.sementeAleatoria);
   }

   public ArrayList<String> pegaCarta(int qnt) {

       ArrayList<String> cartas = new ArrayList<String>();

       for(int i = 0; i < qnt; i++) {
            cartas.add(baralho.get(i));
       }

       return cartas;
   }

   public void setMaoDeOnze(boolean t) {
       this.maoDeOnze = t;
   }
   
   public void exibirMao(ArrayList<String> cartas, String coringa) {

       cartasNaMesa.clear();

       int i = 0;
       int px = 5;
       int py = 5;
       String caminho;
       
       for (String mao : cartas) {
           if (maoDeOnze) {
               caminho = "0o.png";
           } else {
               caminho = mao + ".png";
           }

           Carta ca = new Carta(caminho, false, mao);

           ca.mover(px, py);
           px += 10;
           py += 4;

           this.cartasNaMesa.add(ca);
       }

       for (Carta c : cartasNaMesa) {
           c.mover(150 + (80 * i), 350);
           i++;
       }

       caminho = coringa + ".png";
       Carta cor = new Carta(caminho, false, coringa);
       this.cartasNaMesa.add(cor);
       cartasNaMesa.get(3).mover(430, 200);

       cartasDoAdversario.clear();
       for (int a = 0; a < 3; a++) {
           caminho = "fundoa.png";

           Carta ca = new Carta(caminho, false, "0o");

           ca.mover(150 + (80 * a), 50);

           cartasDoAdversario.add(ca);
       }

       ((Mesa) jPMesa).repaint();

       mensagem("Cartas distribuidas.\n Aguarde...");
   }
   
   public void setPlacar(int pont, String nick2, int pont2) {       
       this.jLNome1.setText(nick + ":");
       if(pont > 12) {  //  Só pra ficar bunitin.
           pont = 12;
       }
       this.jLPont1.setText("" + pont);
       this.jLNome2.setText(nick2 + ":");
       if(pont2 > 12) {
           pont2 = 12;
       }
       this.jLPont2.setText("" + pont2);      
   }
   
    public void limpaCartasJogadas() {
        cartasEmJogo.clear();
        ((Mesa) jPMesa).repaint();
   }
    
    public void limparUmaCartaAdver() {
        cartasDoAdversario.remove(0);
        ((Mesa) jPMesa).repaint();
    }
    
    public void limpaTudoNaMesa() {
        cartasNaMesa.clear();
        cartasEmJogo.clear();
        ((Mesa) jPMesa).repaint();
    }
  
    public void exibirCartaJogada(String carta) {
        
        String caminho = carta + ".png";
        Carta ca = new Carta(caminho, false, carta);

        if (f) {
            ca.mover(160, 200);
            f = false;
        } else {
            ca.mover(270, 200);
            f = true;
        }
        cartasEmJogo.add(ca);

        ((Mesa) jPMesa).repaint();
    }
   
    public void setaProcesso(Processo proc) {
        this.proc = proc;
    }
    
   public void solicitaCarta() {      
       mensagem("Sua vez de cair!\n Escolha uma carta.");
       ((Mesa)jPMesa).turn(true);
       ((Mesa)jPMesa).limparFoco();
        this.botoes = true;
        fsolicitacarta = false;
       //proc.setaJogadorAcao(0);
        
       while (true) {
           //   Caso alguma carta seja selecionada.
           if (((Mesa) jPMesa).cartaSelecionada().length() > 0) {                              
               
               //   Primeiro testa se a carta selecionada não é o coringa.
               if (((Mesa) jPMesa).cartaSelecionada().equals(proc.getCoringa())) {
                   alerta("Você não pode enviar o coringa! Escolha outra carta. =)");
                   ((Mesa) jPMesa).limparFoco();
               }
               //   Testa situação de esconder carta.        
               else if(fesconder) {
                   //   Remove carta selecionada (depois será recriada na nova posição).
                   for (Iterator<Carta> car = cartasNaMesa.iterator(); car.hasNext();) {
                       Carta n = car.next();
                       if (n.getNome().equals(((Mesa) jPMesa).cartaSelecionada())) {
                           car.remove();
                       }
                   }
                   proc.setaJogadorAcao(2);
                   proc.setaCartaAcao(((Mesa) jPMesa).cartaSelecionada());
                   mensagem("Carta selecionada: " + ((Mesa) jPMesa).cartaSelecionada());
                   botoes = false;
                   fesconder = false;
                   break;
               }
               //   Testa enviar carta selecionada.        
               else {
                   //   Remove carta selecionada (depois será recriada na nova posição).
                   for (Iterator<Carta> car = cartasNaMesa.iterator(); car.hasNext();) {
                       Carta n = car.next();
                       if (n.getNome().equals(((Mesa) jPMesa).cartaSelecionada())) {
                           car.remove();
                       }
                   }
                   proc.setaJogadorAcao(1);
                   proc.setaCartaAcao(((Mesa) jPMesa).cartaSelecionada());
                   mensagem("Carta selecionada: " + ((Mesa) jPMesa).cartaSelecionada());
                   botoes = false;                   
                   break;
               }
           }
                   //   Se o flag for ativo sai do loop.
           else if(fsolicitacarta) {
               break;
           }
       }
       //((Mesa)jPMesa).turn(false);
   }

   public void largarMao() {
       this.mensagem("Largou a Mão - largarMao()");
        proc.setaJogadorAcao(3);
        fsolicitacarta = true;
        this.botoes = false;
    }

   public void trucar() throws Exception {
        alerta("Aguarde a resposta do jogador adversário!");                
        
            //  Enviar proposta de truco.
            proc.enviar(207, "TRUCO!");
            int a;
            //  Receber resposta.
            if(fjogoIA) {
                a = ((JogoContraIA)proc).getTrucoResp();                
            } else {
                Mensagem m = proc.receber();
                a = m.getCodigo();                
            }
            
            switch(a) {
                
                    //  Truco aceito.
                case 0:
                    proc.setOnTruco(true);
                    alerta("Truco aceito. Escolha uma carta.");
                    //  Partida passa a valer 3 pontos.
                    if (getPontoPartida() >= 3) {     //  Se partida já estiver trucada.
                        proc.incPontoPartida(3);
                    } else {                        //  Se não > incremento inicial.
                        proc.incPontoPartida(2);
                    }
                    proc.enviar(305, "" + proc.getPontoPartida());
                    break;

                    //  Truco Recusado.
                case 1:
                    proc.setaJogadorAcao(4);
                    alerta("Truco recusado.");                   
                    fsolicitacarta = true;
                    break;
                default:
                    break;
            }
    }
   
   public int getPontoPartida() {
       return proc.getPontoPartida();
   }
   
   public void setOnTruco(boolean a) {
       proc.setOnTruco(a);
   }
   
   boolean ftrucoResp;
   
   public int trucoResposta(String ti) {
       
       ftrucoResp = true;
        //  java.awt.Frame parent deve servir para a mesma coisa que "jFPricipal pai", mas da nada por enquanto \o
       jDEscolher escolha = new jDEscolher(this, botoes, this, ti);
       
       escolha.setLocationRelativeTo(null);
       
       escolha.setVisible(true);
       
       //   Errado.
       while(ftrucoResp);              
       
       return escolha.getResposta();
   }
   
   //   Background.
   public void back(boolean f) {
       
       //   Bg on
       if(f) {
           jLBackground.setVisible(true);
           jPMesa.setBackground(Color.white);
       }    //  Bg off
       else {
           jLBackground.setVisible(false);
           jPMesa.setBackground(new Color(0, 102, 0));
       }
   }
   
   public void enviarChat(String msg) {
       this.jTAChat.append(msg + "\n");
   }
   
//_________________________________________________   
//-------------------Métodos do Servidor    
   public void novoServer(String nick, int porta) {       
       try{
                    //  Exibir mesa de jogo   //
               //Mesa mesa = new Mesa(this, this.baralho);
               jPBackground.setBounds(0, 20, this.getWidth(), this.getHeight());
               this.setContentPane(jPBackground);
               jPBackground.setVisible(true);
               
                    //  Cria objeto para armazenar jogador local    //
               this.nick = nick;
               
                    //  Inicia Socket Servidor    //
               serverSock = new ServidorThread(porta, this);
               serverSock.start();
               this.mensagem("Aguarde a conexão do jogador cliente!");
               alerta("Parâmetros da conexão: IP:" + InetAddress.getLocalHost().getHostAddress()  + " Porta:" + porta);
               this.setTitle("Truco  -  Jogador: " + nick + "  IP:" + InetAddress.getLocalHost().getHostAddress()  + " Porta:" + porta);
               //iniciaPartida(); //teste
       }catch(Exception e) {
           System.out.println("Erro: " + e.toString());
       }
   }
//_________________________________________________   
//-------------------Métodos do Cliente
   public void novoCliente(String nick, int porta, String ipServidor) {
       
       try{
                    //  Exibir mesa de jogo   //
                jPBackground.setBounds(0, 20, this.getWidth(), this.getHeight());
                               this.setContentPane(jPBackground);
               jPBackground.setVisible(true);
                    //  Cria objeto para armazenar jogador local    //
               this.nick = nick;
               
               clienteSock = new ClienteThread(this, nick, ipServidor, porta);
               clienteSock.start();
               
               this.setTitle("Truco  -  Jogador: " + nick + "  Conectado em: IP:" + InetAddress.getLocalHost().getHostAddress()  + " Porta:" + porta);
               
       }catch(Exception e) {
           System.out.println(e.getMessage());
       } 
   }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPBackground = new javax.swing.JPanel();
        jPChat = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTAChat = new javax.swing.JTextArea();
        jTFChatEnviar = new javax.swing.JTextField();
        jPMesa = new Mesa(this, this.cartasNaMesa, suaVez, cartasEmJogo, cartasDoAdversario);
        jLBackground = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        jLNome1 = new javax.swing.JLabel();
        jLNome2 = new javax.swing.JLabel();
        jLPont1 = new javax.swing.JLabel();
        jLPont2 = new javax.swing.JLabel();
        jBTrucar = new javax.swing.JButton();
        jBLargarMao = new javax.swing.JButton();
        jBEsconder = new javax.swing.JButton();
        jPSistema = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTASistema = new javax.swing.JTextArea();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        jMNJRede = new javax.swing.JMenuItem();
        jMNJIA = new javax.swing.JMenuItem();
        jMConectarEmJogo = new javax.swing.JMenuItem();
        jMSair = new javax.swing.JMenuItem();
        jMenu2 = new javax.swing.JMenu();
        jMCaracteristicas = new javax.swing.JMenuItem();
        jMComoJogar = new javax.swing.JMenuItem();
        jMILicenca = new javax.swing.JMenuItem();
        jMSobre = new javax.swing.JMenu();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jPChat.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Chat", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Comic Sans MS", 1, 12))); // NOI18N

        jTAChat.setColumns(10);
        jTAChat.setEditable(false);
        jTAChat.setLineWrap(true);
        jTAChat.setRows(5);
        jTAChat.setWrapStyleWord(true);
        jScrollPane2.setViewportView(jTAChat);

        jTFChatEnviar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTFChatEnviarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPChatLayout = new javax.swing.GroupLayout(jPChat);
        jPChat.setLayout(jPChatLayout);
        jPChatLayout.setHorizontalGroup(
            jPChatLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 224, Short.MAX_VALUE)
            .addComponent(jTFChatEnviar, javax.swing.GroupLayout.DEFAULT_SIZE, 224, Short.MAX_VALUE)
        );
        jPChatLayout.setVerticalGroup(
            jPChatLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPChatLayout.createSequentialGroup()
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 17, Short.MAX_VALUE)
                .addComponent(jTFChatEnviar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        jPMesa.setBackground(new java.awt.Color(255, 255, 255));
        jPMesa.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPMesa.setForeground(new java.awt.Color(255, 255, 255));
        jPMesa.setPreferredSize(new java.awt.Dimension(640, 403));

        jLBackground.setBackground(new java.awt.Color(255, 255, 255));
        jLBackground.setForeground(new java.awt.Color(255, 255, 255));
        jLBackground.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resourcesEtc/truco-no-iphone.jpg"))); // NOI18N

        javax.swing.GroupLayout jPMesaLayout = new javax.swing.GroupLayout(jPMesa);
        jPMesa.setLayout(jPMesaLayout);
        jPMesaLayout.setHorizontalGroup(
            jPMesaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPMesaLayout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jLBackground)
                .addGap(65, 65, 65))
        );
        jPMesaLayout.setVerticalGroup(
            jPMesaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPMesaLayout.createSequentialGroup()
                .addComponent(jLBackground)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Pontuação", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Comic Sans MS", 1, 18))); // NOI18N

        jLNome1.setText("P1:");

        jLNome2.setText("P2:");

        jLPont1.setText("0");

        jLPont2.setText("0");

        jBTrucar.setText("Trucar");
        jBTrucar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBTrucarActionPerformed(evt);
            }
        });

        jBLargarMao.setText("Largar Mão");
        jBLargarMao.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBLargarMaoActionPerformed(evt);
            }
        });

        jBEsconder.setText("Esconder");
        jBEsconder.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBEsconderActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jBLargarMao, javax.swing.GroupLayout.DEFAULT_SIZE, 204, Short.MAX_VALUE)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jLNome1)
                        .addGap(18, 18, 18)
                        .addComponent(jLPont1))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jLNome2)
                        .addGap(18, 18, 18)
                        .addComponent(jLPont2))
                    .addComponent(jBTrucar, javax.swing.GroupLayout.DEFAULT_SIZE, 204, Short.MAX_VALUE)
                    .addComponent(jBEsconder, javax.swing.GroupLayout.DEFAULT_SIZE, 204, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLNome1)
                    .addComponent(jLPont1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLNome2)
                    .addComponent(jLPont2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jBEsconder)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jBTrucar, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 8, Short.MAX_VALUE)
                .addComponent(jBLargarMao)
                .addContainerGap())
        );

        jPSistema.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Sistema", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Comic Sans MS", 1, 12))); // NOI18N

        jTASistema.setColumns(10);
        jTASistema.setEditable(false);
        jTASistema.setLineWrap(true);
        jTASistema.setRows(5);
        jTASistema.setWrapStyleWord(true);
        jTASistema.setDropMode(javax.swing.DropMode.INSERT);
        jScrollPane1.setViewportView(jTASistema);

        javax.swing.GroupLayout jPSistemaLayout = new javax.swing.GroupLayout(jPSistema);
        jPSistema.setLayout(jPSistemaLayout);
        jPSistemaLayout.setHorizontalGroup(
            jPSistemaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 224, Short.MAX_VALUE)
        );
        jPSistemaLayout.setVerticalGroup(
            jPSistemaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPSistemaLayout.createSequentialGroup()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 102, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout jPBackgroundLayout = new javax.swing.GroupLayout(jPBackground);
        jPBackground.setLayout(jPBackgroundLayout);
        jPBackgroundLayout.setHorizontalGroup(
            jPBackgroundLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPBackgroundLayout.createSequentialGroup()
                .addComponent(jPMesa, javax.swing.GroupLayout.PREFERRED_SIZE, 521, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPBackgroundLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jPChat, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPSistema, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
        );
        jPBackgroundLayout.setVerticalGroup(
            jPBackgroundLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPBackgroundLayout.createSequentialGroup()
                .addGroup(jPBackgroundLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPMesa, javax.swing.GroupLayout.DEFAULT_SIZE, 493, Short.MAX_VALUE)
                    .addGroup(jPBackgroundLayout.createSequentialGroup()
                        .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jPSistema, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jPChat, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );

        jMenu1.setText("Jogo");

        jMNJRede.setText("Novo Jogo em Rede");
        jMNJRede.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMNJRedeActionPerformed(evt);
            }
        });
        jMenu1.add(jMNJRede);

        jMNJIA.setText("Novo Jogo contra I.A.");
        jMNJIA.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMNJIAActionPerformed(evt);
            }
        });
        jMenu1.add(jMNJIA);

        jMConectarEmJogo.setText("Conectar em jogo");
        jMConectarEmJogo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMConectarEmJogoActionPerformed(evt);
            }
        });
        jMenu1.add(jMConectarEmJogo);

        jMSair.setText("Sair");
        jMSair.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMSairActionPerformed(evt);
            }
        });
        jMenu1.add(jMSair);

        jMenuBar1.add(jMenu1);

        jMenu2.setText("Ajuda");

        jMCaracteristicas.setText("Características");
        jMCaracteristicas.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMCaracteristicasActionPerformed(evt);
            }
        });
        jMenu2.add(jMCaracteristicas);

        jMComoJogar.setText("Como jogar");
        jMComoJogar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMComoJogarActionPerformed(evt);
            }
        });
        jMenu2.add(jMComoJogar);

        jMILicenca.setText("Licença");
        jMILicenca.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMILicencaActionPerformed(evt);
            }
        });
        jMenu2.add(jMILicenca);

        jMenuBar1.add(jMenu2);

        jMSobre.setText("Sobre");
        jMSobre.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jMSobreMouseClicked(evt);
            }
        });
        jMSobre.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMSobreActionPerformed(evt);
            }
        });
        jMenuBar1.add(jMSobre);

        setJMenuBar(jMenuBar1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPBackground, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPBackground, javax.swing.GroupLayout.PREFERRED_SIZE, 482, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jMSairActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMSairActionPerformed
        System.exit(0);
    }//GEN-LAST:event_jMSairActionPerformed

    private void jMNJRedeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMNJRedeActionPerformed
        this.back(false);   //  Background.
        jPNovoJogoEmRede pNovoJogo = new jPNovoJogoEmRede(this);  
        pNovoJogo.setBounds(0, 20, this.getWidth(), this.getHeight());
        this.setContentPane(pNovoJogo);
        pNovoJogo.setVisible(true);     
    }//GEN-LAST:event_jMNJRedeActionPerformed

    private void jMConectarEmJogoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMConectarEmJogoActionPerformed
        this.back(false);   //  Background.
        jPConectarEmJogo conectarJogo = new jPConectarEmJogo(this);  
        conectarJogo.setBounds(0, 20, this.getWidth(), this.getHeight());
        this.setContentPane(conectarJogo);
        conectarJogo.setVisible(true);  
    }//GEN-LAST:event_jMConectarEmJogoActionPerformed

    private void jBTrucarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBTrucarActionPerformed
        if (!botoes) {
            return;
        }

        if (proc.getPontoPartida() >= 12) {
            alerta("Partida já está valendo 12 pontos.");
            return;
        } else if (proc.getOnTruco() == true) {
            alerta("Você já pediu truco!");
            try {
                proc.enviar(900, nick + " tentou pedir truco novamente.");
            } catch (Exception ex) {
                Logger.getLogger(JFPrincipal.class.getName()).log(Level.SEVERE, null, ex);
            }
            return;
        }

        try {
            trucar();
        } catch (Exception ex) {
            Logger.getLogger(JFPrincipal.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_jBTrucarActionPerformed

    private void jBLargarMaoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBLargarMaoActionPerformed
            if(!botoes) return;
            fsolicitacarta = true;
            this.mensagem("Largou a Mão - Botão Largar a mão");
            largarMao();
    }//GEN-LAST:event_jBLargarMaoActionPerformed

    private void jBEsconderActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBEsconderActionPerformed

        if ((!botoes) && (proc.condEsconder((proc.getRodadas())) == 0)) {
            return;
        } 
        else if (proc.condEsconder((proc.getRodadas())) == 0) {
            alerta("Você não pode esconder na primeira rodada!");
            try {
                proc.enviar(204, "");
            } catch (Exception ex) {
                Logger.getLogger(JFPrincipal.class.getName()).log(Level.SEVERE, null, ex);
            }
            return;
        }        
        
            if(!fesconder) {
                fesconder = true;
                alerta("Escolha uma carta para esconder!");
            }
            else {
                fesconder = false;
                alerta("Escolha uma carta para jogar!");
            }
    }//GEN-LAST:event_jBEsconderActionPerformed

    private void jMNJIAActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMNJIAActionPerformed
        this.back(false);   //  Background.
        jFPedirDados dados = new jFPedirDados(this, true);
        dados.setLocationRelativeTo(null);
        dados.setVisible(true);        
        this.nick = dados.getNick1();
        this.fjogoIA = true;
        JogoContraIA jogoIa = new JogoContraIA(this, dados.getNick1(), dados.getNick2(), dados.getDificuldade());  
        jogoIa.start();
    }//GEN-LAST:event_jMNJIAActionPerformed

    private void jMComoJogarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMComoJogarActionPerformed
        jDComoJogar comoJogar = new jDComoJogar(this, false);
        comoJogar.setLocationRelativeTo(null);
        comoJogar.setVisible(true);
    }//GEN-LAST:event_jMComoJogarActionPerformed

    private void jTFChatEnviarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTFChatEnviarActionPerformed
        if(proc == null) {
            enviarChat("Aguarde alguém conectar-se.");
            return;
        }                
        try {
                proc.enviar(666, nick + ": " + jTFChatEnviar.getText());
            this.enviarChat(nick + ": " + jTFChatEnviar.getText());
            jTFChatEnviar.setText("");
        } catch (Exception ex) {
            Logger.getLogger(JFPrincipal.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_jTFChatEnviarActionPerformed

    private void jMILicencaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMILicencaActionPerformed
        jDLicenca lic = new jDLicenca(this, false);
        lic.setLocationRelativeTo(null);
        lic.setVisible(true);
    }//GEN-LAST:event_jMILicencaActionPerformed

    private void jMSobreActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMSobreActionPerformed
        jDSobre sobre = new jDSobre(this, false);
        sobre.setLocationRelativeTo(null);
        sobre.setVisible(true);
    }//GEN-LAST:event_jMSobreActionPerformed

    private void jMSobreMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jMSobreMouseClicked
        jDSobre sobre = new jDSobre(this, false);
        sobre.setLocationRelativeTo(null);
        sobre.setVisible(true);
    }//GEN-LAST:event_jMSobreMouseClicked

    private void jMCaracteristicasActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMCaracteristicasActionPerformed
        jDCaracteristicas cara = new jDCaracteristicas(this, false);
        cara.setLocationRelativeTo(null);
        cara.setVisible(true);
    }//GEN-LAST:event_jMCaracteristicasActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            @Override
            public void run() {
                new JFPrincipal().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jBEsconder;
    private javax.swing.JButton jBLargarMao;
    private javax.swing.JButton jBTrucar;
    private javax.swing.JLabel jLBackground;
    private javax.swing.JLabel jLNome1;
    private javax.swing.JLabel jLNome2;
    private javax.swing.JLabel jLPont1;
    private javax.swing.JLabel jLPont2;
    private javax.swing.JMenuItem jMCaracteristicas;
    private javax.swing.JMenuItem jMComoJogar;
    private javax.swing.JMenuItem jMConectarEmJogo;
    private javax.swing.JMenuItem jMILicenca;
    private javax.swing.JMenuItem jMNJIA;
    private javax.swing.JMenuItem jMNJRede;
    private javax.swing.JMenuItem jMSair;
    private javax.swing.JMenu jMSobre;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JPanel jPBackground;
    private javax.swing.JPanel jPChat;
    private javax.swing.JPanel jPMesa;
    private javax.swing.JPanel jPSistema;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTextArea jTAChat;
    private javax.swing.JTextArea jTASistema;
    private javax.swing.JTextField jTFChatEnviar;
    // End of variables declaration//GEN-END:variables
}
